/*
 * Copyright 2005, Mamezou Co.,LTD.
 */
package jp.co.thinkit.employee.presentation.struts;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.thinkit.employee.business.EmployeeManager;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * ̃NXׂ͂ĂActionNXɑ΂NXłB
 * @author Mamezou
 * @version 1.0
 */
public abstract class BaseAction extends Action {
    
    protected EmployeeManager employeeManager;
    
    /**
     * RXgN^B
     * ̃NX̃IuWFNg𐶐B
     */
    public BaseAction() {}

    /**
     * y[WJڃ`FbNsʂB
     * ftHgłfalseԂ߃`FbNsꍇ
     * \bhI[o[ChB
     * @return ftHgfalse
     */
    protected boolean isTransitCheckAction() {
        return false;
    }
  
    /**
     * ANVsB
     * @param mapping }bsO
     * @param form Form BeanIuWFNg
     * @param req@HTTPNGXg
     * @param res HTTPX|X
     * @return JڐActionForwardIuWFNg
     * @throws Exception TuNXɂ茈肷
     */
    final public ActionForward execute(ActionMapping mapping, ActionForm form,
                               HttpServletRequest req, HttpServletResponse res)
      throws Exception
    {

        ActionForward foward = null;
    
        // Jڃ`FbNs
        if (isTransitCheckAction()) {
            if (!isTokenValid(req)) {
                throw new Exception("sȉʑJڂł");
            }
        }
    
        // rWlXwŔׂĂ̎sOߑ
        try {

            String result = this.doExecute(form, req);

            // ʂɊÂActionForward擾
            foward = getActionForward(result, mapping);
        } catch (Exception ex) { // `FbNςݗOߑ
            System.out.println(ex);
            throw ex;
        }
    
        // ʂJڂǐՂTokenftHgŐ
        saveToken(req);

        return foward;
    }

   /**
    * TuNX̃ANV̏s
    * @param form@FormBeanIuWFNg
    * @param req HTTPNGXg
    * @return ʂԂ
    * @throws Exception throw\Exceptionthrowsɏ
    */
    protected abstract String doExecute(ActionForm form, 
                                       HttpServletRequest req)
      throws Exception;

   /**
    * Jڐ̉ʖActionForward擾
    * @param result Jڐ敶
    * @param mapping ̃ANVmappingIuWFNg
    * @return ActionForwardIuWFNg
    */
    private ActionForward getActionForward(String result, ActionMapping mapping)
      throws Exception {
        ActionForward af = mapping.findForward(result);
        if (af == null) {
            throw new Exception("not define result in mapping..[result="
                                                                  + result + "]");
        }
        return af;
    }
}