/*
 * Copyright 2005, Mamezou Co.,LTD.
 */
package jp.co.thinkit.employee.presentation.struts;

import javax.servlet.http.HttpServletRequest;

import jp.co.thinkit.employee.validation.EmployeeValidator;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

/**
 * ]ƈǉActionFormNX
 * @author Mamezou
 * @version 1.0
 */
public class AddForm extends ActionForm {
    private String name;
    private String address;

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        ActionErrors errors = new ActionErrors();
        
        if (EmployeeValidator.isString(name)) {
            errors.add("name", new ActionMessage("error.required.name"));
        }
        
        if (EmployeeValidator.isString(address)) {
            errors.add("address", new ActionMessage("error.required.address"));
        }    
        return errors;
    }
}
